<?php

function dialectic_rot13($text) {
  return str_rot13($text);
}

function dialectic_morse($text) {
  // First strip out things that will cause confusion.
  $text = preg_replace("/[^a-zA-Z0-9\.!?\,\@\(\)\& ]/", '', trim(strtolower($text)));

  $lookup = array(
    ' ' => ' /',
    '.' => ' .-.-.-',
    ',' => ' --..--',
    '?' => ' ..--..',
    '!' => ' -.-.--',
    '(' => ' -.--.',
    ')' => ' -.--.-',
    '&' => ' . ...',
    '@' => ' .--.-.',
    'a' => ' .-',
    'b' => ' -...',
    'c' => ' -.-.',
    'd' => ' -..',
    'e' => ' .',
    'f' => ' ..-.',
    'g' => ' --.',
    'h' => ' ....',
    'i' => ' ..',
    'j' => ' .---',
    'k' => ' -.-',
    'l' => ' .-..',
    'm' => ' --',
    'n' => ' -.',
    'o' => ' ---',
    'p' => ' .--.',
    'q' => ' --.-',
    'r' => ' .-.',
    's' => ' ...',
    't' => ' -',
    'u' => ' ..-',
    'v' => ' ...-',
    'w' => ' .--',
    'x' => ' -..-',
    'y' => ' -.--',
    'z' => ' --..',
    '0' => ' -----',
    '1' => ' .----',
    '2' => ' ..---',
    '3' => ' ...--',
    '4' => ' ....-',
    '5' => ' .....',
    '6' => ' -....',
    '7' => ' --...',
    '8' => ' ---..',
    '9' => ' ----.',
  );

  $search = array_keys($lookup);
  $replace = array_values($lookup);
  return str_replace($search, $replace, $text);
}

function dialectic_ubby($text) {
  return preg_replace(array("/([aeiou])/", "/([AEIOU])/"), array("ubb\\1", "UBB\\1"), $text);
}

function dialectic_pig($text) {
  $e = explode(' ', $text);
  $text = '';
  while (list($n, $w) = each($e)) {
    if (preg_match("/[a-z0-9]/i", $w)) {
      if (preg_match("/[b-df-hj-np-tv-z0-9]/i", $w[0])) {
        $w = tr($w, $i + 1) . $w[$i] . 'ay';
      }
      else {
        $w .= 'ay';
      }
    }
    $w = preg_replace("/([^\,\.]*)([\,\.]*)([b-df-hj-np-tv-z0-9]{0,1}(ay){0,1})/i","\\1\\3\\2", $w);
    $text .= $w . ' ';
  }
  return substr($text, 0, -1);
}

function dialectic_fudd($text) {
  $patterns = array(
    '/[rl]/' => 'w',
    '/[RL]/' => 'W',
    '/qu/' => 'qw',
    '/Qu/' => 'Qw',
    '/QU/' => 'QW',
    '/([^ ])th([^aeiouAEIOU])/' => '\\1f\\2',
    '/([^ ])Th|TH([^aeiouAEIOU])/' => '\\1F\\2',
    '/ th([aeiou])/' => ' d\\1',
    '/ Th|TH([aeiouAEIOU])/' => ' D\\1',
    '/n[\.]/' => 'n, uh-hah-hah-hah.',
  );
  $search = array_keys($patterns);
  $replace = array_values($patterns);
  return preg_replace($search, $replace, $text);
}

function dialectic_warez($text) {
  $text = strtolower($text);

  $patterns = array(
    '/\.([^a-z0-9])/' => '!!\\1',
    '/\?/' => '?!?',
    '/[\']/' => '"',
    '/dude/' => 'D00D',
    '/([^ ])ould/' => '\\1UD',
    '/([^ ])ough/' => '\\1UF',
    '/([^ ])augh/' => '\\1AFF',
    '/([^ ])ile/' => '\\1IEL',
    '/([^a-z0-9])to([^a-z0-9])/' => '\\1 2 \\2',
    '/([^a-z0-9])your/' => '\\1UR',
    '/([^a-z0-9])you/' => '\\1U',
    '/([^a-z0-9])was/' => '\\1WUZ',
    '/([^a-z0-9])says/' => '\\1SEZ',
    '/for|four/' => '4',
    '/s/' => '5',
    '/ate/' => '8',
    '/([^a-z0-9])be/' => '\\1B',
    '/([^a-z0-9])see/' => '\\1C',
    '/([^a-z0-9])am/' => '\\1M',
    '/([^a-z0-9])are/' => '\\1R',
    '/([^a-z0-9])ex/' => '\\1X',
    '/([^a-z0-9])why/' => '\\1Y',
    '/ph/' => 'F',
    '/ch/' => 'CH',
    '/([^a-z0-9])c/' => '\\1K',
    '/ea/' => 'EE',
    '/and/' => '&',
    '/([a-z])se([^a-z0-9])/' => '\\1EZ\\2',
    '/([a-z])es|s([^a-z0-9])/' => '\\1Z\\2',
    '/([^a-z0-9])s/' => '\\1Y',
    '/e/' => '3',
    '/a/' => '4',
    '/t/' => '+',
    '/k/' => '|<',
    '/o/' => '0',
    '/i/' => '1',
  );
  $search = array_keys($patterns);
  $replace = array_values($patterns);
  return preg_replace($search, $replace, $text);
}

function dialectic_pirate($text) {
  $patterns = array(
    '%\bmy\b%' => 'me',
    '%\bboss\b%' => 'admiral',
    '%\bmanager\b%' => 'admiral',
    '%\b[Cc]aptain\b%' => "Cap'n",
    '%\bmyself\b%' => 'meself',
    '%\byour\b%' => 'yer',
    '%\byou\b%' => 'ye',
    '%\bfriend\b%' => 'matey',
    '%\bfriends\b%' => 'maties',
    '%\bco[-]?worker\b%' => 'shipmate',
    '%\bco[-]?workers\b%' => 'shipmates',
    '%\bearlier\b%' => 'afore',
    '%\bold\b%' => 'auld',
    '%\bthe\b%' => "th'",
    '%\bof\b%' =>  "o'",
    "%\bdon't\b%" => "dern't",
    '%\bdo not\b%' => "dern't",
    '%\bnever\b%' => "ne'er",
    '%\bever\b%' => "e'er",
    '%\bover\b%' => "o'er",
    '%\bYes\b%' => 'Aye',
    '%\bNo\b%' => 'Nay',
    "%\bdon't know\b%" => "dinna",
    "%\bhadn't\b%" => "ha'nae",
    "%\bdidn't\b%" => "di'nae",
    "%\bwasn't\b%" => "weren't",
    "%\bhaven't\b%" => "ha'nae",
    '%\bfor\b%' => 'fer',
    '%\bbetween\b%' => 'betwixt',
    '%\baround\b%' => "aroun'",
    '%\bto\b%' => "t'",
    "%\bit's\b%" => "'tis",
    '%\bwoman\b%' => 'wench',
    '%\blady\b%' => 'wench',
    '%\bwife\b%' => 'lady',
    '%\bgirl\b%' => 'lass',
    '%\bgirls\b%' => 'lassies',
    '%\bguy\b%' => 'lubber',
    '%\bman\b%' => 'lubber',
    '%\bfellow\b%' => 'lubber',
    '%\bdude\b%' => 'lubber',
    '%\bboy\b%' => 'lad',
    '%\bboys\b%' => 'laddies',
    '%\bchildren\b%' => 'little sandcrabs',
    '%\bkids\b%' => 'minnows',
    '%\bhim\b%' => 'that scurvey dog',
    '%\bher\b%' => 'that comely wench',
    '%\bhim\.\b%' => 'that drunken sailor',
    '%\bHe\b%' => 'The ornery cuss',
    '%\bShe\b%' => 'The winsome lass',
    "%\bhe's\b%" => 'he be',
    "%\bshe's\b%" => 'she be',
    '%\bwas\b%' => "were bein'",
    '%\bHey\b%' => 'Avast',
    '%\bher\.\b%' => 'that lovely lass',
    '%\bfood\b%' => 'chow',
    '%\broad\b%' => 'sea',
    '%\broads\b%' => 'seas',
    '%\bstreet\b%' => 'river',
    '%\bstreets\b%' => 'rivers',
    '%\bhighway\b%' => 'ocean',
    '%\bhighways\b%' => 'oceans',
    '%\bcar\b%' => 'boat',
    '%\bcars\b%' => 'boats',
    '%\btruck\b%' => 'schooner',
    '%\btrucks\b%' => 'schooners',
    '%\bSUV\b%' => 'ship',
    '%\bairplane\b%' => 'flying machine',
    '%\bjet\b%' => 'flying machine',
    '%\bmachine\b%' => 'contraption',
    '%\bdriving\b%' => 'sailing',
    '%\bdrive\b%' => 'sail',
    '/ing\b/' => "in'",
    '/ings\b/' => "in's",
    // These next two do cool random substitutions
    '/(\.\s)/e' => '_dialectic_avast("$0",3)',
    '/([!\?]\s)/e' => '_dialectic_avast("$0",2)', // Greater chance after exclamation
  );
  $search = array_keys($patterns);
  $replace = array_values($patterns);
  return preg_replace($search, $replace, $text);
}

function dialectic_chef($text) {
    $patterns = array(

    '%an%' => 'un',
    '%An%' => 'Un',

    '%au%' => 'oo',
    '%Au%' => 'Oo',
    '%(\w)ew%' => '$1oo',
    '%(\w)ow%' => '$1oo',
    '%(\W)o%' => '$1oo',
    '%(\W)O%' => '$1Oo',
    '%(\w)u%' => '$1oo',
    '%(\w)U%' => '$1Oo',

    '%a(\w)%' => 'e$1',
    '%A(\w)%' => 'E$1',
    '%en(\W)%' => 'ee$1',

    '%(\w)e(\W)%' => '$1e-a$2',
    '%(\W)e%' => '$1i',
    '%(\W)E%' => '$1I',

    '%(\w)f%' => '$1ff',

    '%(\w)ir%' => '$1ur',

    '%([a-m])i%' => '$1ee',
    '%([A-M])i%' => '$1EE',

    '%(\w)o%' => '$1u',
    '%the%' => 'zee',
    '%The%' => 'Zee',
    '%th(\W)%' => 't$1',
    '%(\w)tion%' => '$1shun',
    '%v%' => 'f',
    '%V%' => 'F',
    '%w%' => 'v',
    '%W%' => 'V',


    '%f{2,}%' => 'ff',
    '%o{2,}%' => 'oo',
    '%e{2,}%' => 'ee',

    '%([\.!\?])\s*(</[^>]+>)?\s*$%' => '$1 Bork Bork Bork!$2',
  );

  $search = array_keys($patterns);
  $replace = array_values($patterns);
  return preg_replace($search, $replace, $text);
}

function dialectic_jive($text) {
  $patterns = array(
    '%file%' => 'stash',
    '%send%' => "t'row",
    '%program%' => 'honky code',
    '%atlas%' => 'Isaac',
    '%unix%' => 'slow mo-fo',
    '%UNIX%' => 'that slow mo-fo',
    '%takes%' => "snatch'd",
    '%Mexican%' => 'wet-back',
    '%Italian%' => 'greaser',
    '%take%' => 'snatch',
    "%don't%" => "duzn't",
    '%jive%' => 'JIBE',
    '%fool%' => 'honkyfool',
    '%modem%' => 'doodad',
    '%e the %' => 'e da damn ',
    '%a the %' => 'a da damn ',
    '%t the %' => 't da damn ',
    '%d the %' => 'd da damn ',
    '% man %' => ' dude ',
    '%woman%' => 'mama',
    '%girl%' => 'goat',
    '%somethin%' => "sump'n",
    '% lie %' => ' honky jibe ',
    '%([a-b]\.)%' => '$1 Sheeeiit.',
    '%([e-f]\.)%' => '$1 What it is, Mama!',
    '%([i-j]\.)%' => "$1 Ya' know?",
    '%([m-n]\.)%' => "$1 'S coo', bro.",
    '%([q-r]\.)%' => '$1 Ah be baaad...',
    '%([u-v]\.)%' => '$1 Man!',
    '%([y-z]\.)%' => '$1 Slap mah fro!',
    '%Sure%' => "Sho' nuff",
    '%sure%' => "sho' nuff",
    '% get	%' => ' git',
    '%will have%' => "gots'ta",
    '%will%' => "gots'ta ",
    '%got to%' => "gots'ta",
    '%I am%' => "I's gots'ta be",
    '%am not %' => 'aint ',
    '%is not %' => 'aint ',
    '%are not %' => 'aint',
    '% are your	%' => " is yo' ",
    '% are you	%' => ' you is ',
    '% hat %' => ' fedora ',
    '% shoe %' => ' kicker ',
    "%haven't%" => 'aint',
    '%have to%' => "gots'ta",
    '%have%' => "gots'",
    '% has%' => " gots'ta",
    '%come over%' => 'mosey on down',
    '% come %' => ' mosey on down ',
    '%!%' => '.  Right On!',
    '%buy	%' => 'steal',
    '% car %' => ' wheels ',
    '%drive%' => 'roll',
    '% eat %' => ' feed da bud ',
    '% black %' => ' brother ',
    '% negro %' => ' brother',
    '%white%' => 'honky',
    '%nigger%' => ' gentleman ',
    '%nice%' => "supa' fine",
    '%person%' => "sucka'",
    '% thing%' => ' wahtahmellun',
    '%home%' => 'plantation',
    '%name%' => 'dojigger',
    '% path%' => ' alley',
    '%computer%' => 'clunker',
    '%or%' => "o'",
    '%killed%' => 'wasted',
    '%president%' => 'super-dude',
    '%prime minister%' => 'super honcho',
    '%injured%' => 'hosed',
    '%government%' => "guv'ment",
    '%knew%' => 'knowed',
    '%because%' => "a'cuz",
    '%Because%' => "A'cuz",
    '%your%' => "yo'",
    '%Your%' => "Yo'",
    '%four%' => 'foe',
    '%got%' => 'gots',
    '%super%' => 'hella',
    '%very%' => 'hella',
    "%aren't%" => "ain't",
    '%young%' => 'yung',
    '%you%' => "ya'",
    '%You%' => "You's",
    '%first%' => 'fust',
    '%police%' => 'honky pigs',
    '% string%' => " chittlin'",
    '% read%' => ' eyeball',
    '%write%' => 'scribble',
    '%th%' => 'd',
    '%Th%' => 'D',
    '%ing%' => "in'",
    '% a %' => ' some ',
    '% to\s+%' => " t'",
    '%tion%' => 'shun',
    '% almost %' => " mos' ",
    '% from%' => ' fum',
    '% because %' => " cuz' ",
    "%you're%" => 'youse',
    "%You're%" => 'Youse',
    '%alright%' => "coo'",
    '%okay%' => "coo'",
    '%er %' => "a' ",
    '%known%' => 'knode',
    '%want%' => "wants'",
    '%beat%' => "whup'",
    '%exp%' => "'sp",
    '%exs%' => "'s",
    '% exc%' => " 's",
    '% ex%' => " 'es",
    '%like%' => 'likes',
    '%did	%' => 'dun did',
    '%kind of%' => "kind'a",
    '%women%' => 'honky chicks',
    '% men %' => ' dudes ',
    '% mens %' => ' dudes ',
    '% man %' => ' dude ',
    '%woman%' => 'honky chick',
    '%dead%' => 'wasted',
    '%good%' => 'baaaad',
    '%open %' => 'jimmey ',
    '%opened %' => "jimmey'd ",
    '% very%' => ' real',
    '%per%' => "puh'",
    '%pera%' => "puh'",
    '%oar%' => "o'",
    '% can%' => ' kin',
    '%just %' => 'plum ',
    '%detroit%' => 'Mo-town',
    '%western electric%' => "da' cave",
    '% believe%' => " recon'",
    '%[Ii]ndianapolis%' => 'Nap-town',
    '% [Jj]ack%' => ' Buckwheat',
    '% [Bb]ob %' => " Liva' Lips ",
    '% [Pp]hil %' => ' dat fine soul ',
    '% [Mm]ark %' => ' Amos ',
    '%[Rr]ober%' => 'Leroy',
    '%[Ss]andy%' => 'dat fine femahnaine ladee',
    '%[Jj]ohn %' => "Raz'tus ",
    '% [Pp]aul%' => " Fuh'rina",
    '%[Rr]eagan%' => 'Kingfish',
    '%[Dd]avid%' => 'Issac',
    '%[Rr]onald%' => 'Rolo',
    '% [Jj]im %' => ' Bo-Jangles ',
    '% [Mm]ary%' => ' Snow Flake',
    '%[Ll]arry%' => 'Remus',
    '%[Jj]oe%' => "Massa' ",
    '%[Jj]oseph%' => "Massa' ",
    '%mohammed%' => "liva' lips",
    '%pontiff%' => "wiz'",
    '%pope%' => "wiz'",
    '%pravda%' => 'dat commie rag',
    '%broken%' => "bugger'd",
    '%strange %' => 'funky ',
    '%dance %' => 'boogy ',
    '% house%' => ' crib',
    '%ask	%' => "ax'",
    '% so %' => " so's ",
    '%head%' => "'haid",
    '%boss%' => 'main man',
    '%wife%' => 'mama',
    '%people%' => "sucka's",
    '%money%' => "bre'd",
    '%([a-z]):%' => '$1, dig dis:',
    '%amateur%' => "begina'",
    '%radio	%' => "transista'",
    '% of %' => ' uh ',
    '%what%' => 'whut',
    '%does%' => 'duz',
    '%was%' => 'wuz',
    '% were%' => ' wuz',
    '%understand it%' => 'dig it',
    '%understand%' => 'dig it',
    '% my%' => " mah'",
    '% [Ii] %' => " ah' ",
    '%meta%' => "meta-fuckin'",
    '%hair%' => 'fro',
    '%talk%' => 'rap',
    '%music%' => 'beat',
    '%basket%' => 'hoop',
    '%football%' => 'ball',
    '%friend%' => 'homey',
    '%school%' => 'farm',
    '%boss%' => 'Man',
    '%want to%' => 'wanna',
    '%wants to%' => "be hankerin' aftah",
    '%well%' => 'sheeit',
    '%Well%' => 'Sheeit',
    '%big%' => 'big-ass',
    '%bad%' => 'bad-ass',
    '%small%' => 'little-ass',
    '%sort of%' => 'radical',
    '% is %' => ' be ',
    '%water%' => 'booze',
    '%book%' => "scribblin'",
    '%magazine%' => 'issue of GQ',
    '%paper%' => 'sheet',
    '%\bup\b%' => 'down',
    '%\bdown\b%' => 'waaay down',
    '%break%' => 'boogie',
    '%Hi%' => "'Sup, dude",
    '%VAX%' => 'pink Cadillac',
  );

  $search = array_keys($patterns);
  $replace = array_values($patterns);
  return preg_replace($search, $replace, $text);
}

function _dialectic_avast($stub = '', $chance = 5) {
  $shouts = array(
    ", avast$stub",
    "$stub Ahoy!",
    ", and a bottle of rum!",
    ", by Blackbeard's sword$stub",
    ", by Davy Jones' locker$stub",
    "$stub Walk the plank!",
    "$stub Aarrr!",
    "$stub Yaaarrrrr!",
    ", pass the grog!",
    ", and dinna spare the whip!",
    ", with a chest full of booty$stub",
    ", and a bucket o' chum$stub",
    ", we'll keel-haul ye!",
    "$stub Shiver me timbers!",
    "$stub And hoist the mainsail!",
    "$stub And swab the deck!",
    ", ye scurvey dog$stub",
    "$stub Fire the cannons!",
    ", to be sure$stub",
    ", I'll warrant ye$stub",
  );

  shuffle($shouts);

  return (((1 == rand(1, $chance)) ? array_shift($shouts) : $stub) . ' ');
}

function dialectic_upsidedown($text) {
  $substitutions = array (
    ' ' => ' ',
    '!' => "¡",          # ¡
    '"' => "„",          # „
    '#' => '#',
    '$' => '$',
    '%' => '%',
    '&' => "⅋",          # ⅋
    "'" => "͵",          # ͵
    '(' => ')',
    ')' => '(',
    '*' => '*',
    '+' => '+',
    ',' => "‘",          # ‘
    '-' => '-',
    '.' => "˙",          # ˙
    '/' => '/',
    '0' => '0',
    '1' => "⃓",  # ,⃓ can be improved
    '2' => "ჷ",          # ჷ
    '3' => "ε",          # ε
    '4' => "⇁⃓",  # ⇁⃓ can be improved
    '5' => "ᔕ",          # ᔕ or maybe just "S"
    '6' => '9',
    '7' => "_̸",  # _̸
    '8' => '8',
    '9' => '6',
    ':' => ':',
    ';' => "⋅̕",  # ⋅̕ sloppy, should be improved
    '<' => '>',
    '=' => '=',
    '>' => '<',
    '?' => "¿",          # ¿
    '@' => '@',                 # can be improved
    'A' => "Ꮜ",          # Ꮜ
    'B' => "ϴ",          # ϴ can be improved
    'C' => "Ɔ",          # Ɔ
    'D' => 'p',                 # should be an uppercase D!!
    'E' => "Ǝ",          # Ǝ
    'F' => "Ⅎ",          # Ⅎ
    'G' => "⅁",          # ⅁
    'H' => 'H',
    'I' => 'I',
    'J' => "ſ",  # ſ̲
    'K' => "ʞ",          # ʞ should be an uppercase K!!
    'L' => "⅂",          # ⅂
    'M' => "Ɯ",          # Ɯ or maybe just "W"
    'N' => 'N',
    'O' => 'O',
    'P' => 'd',                 # should be uppercase P
    'Q' => "Ծ",          # Ծ can be improved
    'R' => "Ȣ",          # Ȣ can be improved
    'S' => 'S',
    'T' => "⊥",          # ⊥
    'U' => "ᑎ",          # ᑎ
    'V' => "Λ",          # Λ
    'W' => 'M',
    'X' => 'X',
    'Y' => "⅄",          # ⅄
    'Z' => 'Z',
    '[' => ']',
    '\\' => '\\',
    ']' => '[',
    '^' => "‿",          # ‿
    '_' => "‾",          # ‾
    '`' => " ̖",  #  ̖
    'a' => "ɐ",          # ɐ
    'b' => 'q',
    'c' => "ɔ",          # ɔ
    'd' => 'p',
    'e' => "ǝ",          # ǝ
    'f' => "ɟ",          # ɟ
    'g' => "ɓ",          # ɓ
    'h' => "ɥ",          # ɥ
    'i' => "ı̣",  # ı̣
    'j' => "ſ",  # ſ̣
    'k' => "ʞ",          # ʞ
    'l' => "Ʈ",          # Ʈ can be improved
    'm' => "ɯ",          # ɯ
    'n' => 'u',
    'o' => 'o',
    'p' => 'd',
    'q' => 'b',
    'r' => "ɹ",          # ɹ
    's' => 's',
    't' => "ʇ",          # ʇ
    'u' => 'n',
    'v' => "ʌ",          # ʌ
    'w' => "ʍ",          # ʍ
    'x' => 'x',
    'y' => "ʎ",          # ʎ
    'z' => 'z',
    '{' => '}',
    '|' => '|',
    '}' => '{',
    '~' => "∼",          # ∼
  );
  $find = array_keys($substitutions);
  $replace = array_values($substitutions);

  return str_replace($find, $replace, $text);
}
